new;
library cml,pgraph;
#include cml.ext;
graphset;
cmlset;


outwidth 255;





cls;
/* INITIALIZATION */
boot      = 0;
dist      = 40;
leer      = 1;
nulo      = 999999;
penalty   = 1000;
param_o   = 0; 
param_b   = 0; 
p_x       = 0;
A         = 0;
gmm       = 0;
gmo       = 0;
gmp       = 0;
gmmvcx    = 0;
gmmvar    = 0;
gmmpen    = 0;



cls;
/* initialization of control variables */
metodoA   = 0;  /* different restrictions on A
                                1  = basic set up: only domestic constraints and zerosin the monetary policy reaction
                                2  = the previous one but spillovers are restricted to be between -1 and 1 or -1 and 0
                                3  = the same as before but now us has to have a bigger effect.
                                
                                11 = basic set up: only domestic constraints and monetary policy reaction is allowed to REACT to german inflation
                                12 = the previous one but spillovers are restricted to be between -1 and 1 or -1 and 0
                                13 = the same as before but now us has to have a bigger effect.
                                                         */
   
metodoret = 2;              /* number of days to compute the returns */

metodovar = 1;              /* decides if we run a VAR */
lags      = 6;              /* lags for the VAR */

metodonor = 1;
                            /* method of normalization 
                                0 = normalizes using the standard deviation 
                                1 = basis points
                                2 = normalizes with a given vector          
                                                        */

win       = 20;             /* number of consecutive observations to compute 
                                the rolling window      */
limit     = 1.0;
minobs    = 4*4;


metodoint = 1;
                            /* computing the interest rates as
                                1 = levels
                                2 = first differences
                                3 = levels but long rates as yield
                                4 = first differences and long rates as yields
                                                        */

metodotim = 0;
                            /* what is the sample in which this is run
                                0 = runs on the full data set
                                1 = runs the data between winini and winfin
                                    the format is year- month-day (19990101) in which the data starts 
                                2 = it eliminates the NBER days after running the VAR. 
                                3 = dates and it eliminates the NBER days after running the VAR. */

winini    = 19990101;
winfin    = 20081231;       /* last day 20081231 */


metodocom = 1;              /* common shocks
                                0 =  no common shocks
                                1 = there is a common shock and the number is especified in k */
k = 1;

metodored = 1;              /* one means that we run with constraints on the reduced form */


metodoreg = 0;              /* 0 = means that we run using only the single variable regimes
                               1 = includes all the possiible variance regimes */

datatype    = 2;            /* which data file to load */ 






/* robustness tests */
/* common factors 
    metodoret = 2;
    lags      = 3;
    win       = 20;
    metodotim = 0; 
    datatype    = 3; 
*/
/* shorter sample 
    metodoret = 2;   
    lags      = 5;   
    win       = 20;  
    metodotim = 1;   
    datatype    = 2; 
*/
/* excluding recessions 
    metodoret = 2;   
    lags      = 10;  
    win       = 20;  
    metodotim = 2;   
    datatype    = 2; 
*/
/* 5-day returns 
    metodoret = 5;   
    lags      = 11;  
    win       = 20;  
    metodotim = 0;   
    datatype    = 2; 
*/
/* 10-day roling window 
    metodoret = 2;   
    lags      = 10;  
    win       = 10;  
    metodotim = 0;   
    datatype    = 2; 
*/
/* 30-day rolling window 
    metodoret = 2;   
    lags      = 10;  
    win       = 30;  
    metodotim = 0;   
    datatype    = 2; 
*/
/* excluding financial crises 
    metodoret = 2;   
    lags      = 9;   
    win       = 20;  
    metodotim = 2;   
    datatype    = 4; 
*/
/* use all variance regimes 
    metodoret = 2;   
    lags      = 12;  
    win       = 20;  
    metodotim = 0;   
    datatype    = 2; 
    metodoreg = 1;   
*/


t=8;
Archivo = "ECBred__________________________________.res";
Archivo = strput(ftocv(metodoret,1,0),Archivo,t); t=t+1;
                                                  t=t+1;
Archivo = strput(ftocv(metodovar,1,0),Archivo,t); t=t+1;
                                                  t=t+1;
Archivo = strput(ftocv(win      ,2,0),Archivo,t); t=t+2;
Archivo = strput(ftocv(limit*10 ,2,0),Archivo,t); t=t+2;
                                                  t=t+1;
Archivo = strput(ftocv(minobs   ,2,0),Archivo,t); t=t+2;
Archivo = strput(ftocv(metodotim,1,0),Archivo,t); t=t+1;
Archivo = strput(ftocv(metodocom,1,0),Archivo,t); t=t+1;
Archivo = strput(ftocv(k        ,1,0),Archivo,t); t=t+1;
                                                  t=t+1;
Archivo = strput(ftocv(metodonor,1,0),Archivo,t); t=t+1;
                                                  t=t+1;
Archivo = strput(ftocv(metodoint,1,0),Archivo,t); t=t+1;
                                                  t=t+1;
Archivo = strput(ftocv(metodoA  ,2,0),Archivo,t); t=t+2;
                                                  t=t+1;
Archivo = strput(ftocv(metodoreg,1,0),Archivo,t); t=t+1;
                                                  t=t+1;
Archivo = strput(ftocv(boot     ,3,0),Archivo,t); t=t+3;
                                                  t=t+1;
Archivo = strput(ftocv(lags     ,1,0),Archivo,t); t=t+1;
                                                  t=t+3;
Archivo = strput(ftocv(datatype ,1,0),Archivo,t); t=t+1;


t=8;
ArchXLS = "ECBred_______________________";
ArchXLS = strput(ftocv(metodoret,1,0),ArchXLS,t); t=t+1;
ArchXLS = strput(ftocv(metodovar,1,0),ArchXLS,t); t=t+1;
ArchXLS = strput(ftocv(win      ,2,0),ArchXLS,t); t=t+2;
ArchXLS = strput(ftocv(limit*10 ,2,0),ArchXLS,t); t=t+2;
ArchXLS = strput(ftocv(minobs   ,2,0),ArchXLS,t); t=t+2;
ArchXLS = strput(ftocv(metodotim,1,0),ArchXLS,t); t=t+1;
ArchXLS = strput(ftocv(metodocom,1,0),ArchXLS,t); t=t+1;
ArchXLS = strput(ftocv(k        ,1,0),ArchXLS,t); t=t+1;
ArchXLS = strput(ftocv(metodonor,1,0),ArchXLS,t); t=t+1;
ArchXLS = strput(ftocv(metodoint,1,0),ArchXLS,t); t=t+1;
ArchXLS = strput(ftocv(metodoA  ,2,0),ArchXLS,t); t=t+2;
ArchXLS = strput(ftocv(metodoreg,1,0),ArchXLS,t); t=t+1;
ArchXLS = strput(ftocv(boot     ,3,0),ArchXLS,t); t=t+3;
ArchXLS = strput(ftocv(lags     ,1,0),ArchXLS,t); t=t+1;
                                                  t=t+1;
ArchXLS = strput(ftocv(datatype ,1,0),ArchXLS,t); t=t+1;

? $Archivo; ? $ArchXLS;


output file=^Archivo reset; 
    ? $Archivo; 
    ? "metodoA"     metodoA;
    ? "metodoret"   metodoret;
    ? "metodovar"   metodovar;
    ? "lags"        lags;
    ? "metodonor"   metodonor;
    ? "win"         win;
    ? "limit"       limit;
    ? "minobs"      minobs;
    ? "metodoint"   metodoint;
    ? "metodotim"   metodotim;
output off;





/* Reading the data */
? "reading";
if leer eq 1;
    elseif datatype eq 2;
        load d[] = "ECBData.csv";    
    elseif datatype eq 3;
        load d[] = "ECBData_commonfactor.csv";
    elseif datatype eq 4;
        load d[] = "ECBData_crises.csv";
    else;
        stop;
    endif;
    
    ECBData = reshape(d,rows(d)/42,42);
    
    v        = { boolean, year, month, day, 
                ir3mea,	ir10yea, ir3mus, ir10yus, eusea, pus, pea3,
                agdpuu,	consconfuu,	cpiuu,	fgdpuu,	housestuu,	indproduu,	napmuu,	nonfpayruu,	
                pgdpuu,	ppiuu,	retsaleuu,	tbguu,	unempruu,	workweekuu,	
                s3cpimgu,	gdpwqgu,	gdppgqgu, ifobcgu,	ipmgu,	ipwmgu,	mordmgu, ppimgu,	ppiwmgu,
            	retmgu,	tradebgu,	unwcgu,	sp1m3ygu, sp1uncgu,	sp2m3ygu,	oilprice, nber
                    };

    ECBData = miss(ECBData,nulo);
    ? rows(ECBData); 
    ? ECBData[rows(ECBData),.]; 

    saved(ECBData,"ECBData",v);
else;
    ECBData  = loadd("ECBData");
    v        = getname("ECBData");
endif;



/********************/
/*    Estimation    */
/********************/

/* Data
         BOOLEAN 1
            YEAR 2
           MONTH 3
             DAY 4
          IR3MEA 5          short EA rate
         IR10YEA 6         long EA rate
          IR3MUS 7         short US rate 
         IR10YUS 8         long US rate
           EUSEA 9         Exchange rates
             PUS 10         stock market: US
            PEA3 11         stock market: EA

NEWS:
          AGDPUU 12     news from US
        CONSCONF 13
           CPIUU 14
          FGDPUU 15
        HOUSESTU 16
        INDPRODU 17
          NAPMUU 18
        NONFPAYR 19
          PGDPUU 20
           PPIUU 21
        RETSALEU 22
           TBGUU 23
        UNEMPRUU 24
        WORKWEEK 25
        S3CPIMGU 26     news fromm Germany/EA
         GDPWQGU 27
        GDPPGQGU 28
         IFOBCGU 29
           IPMGU 30
          IPWMGU 31
         MORDMGU 32
          PPIMGU 33
         PPIWMGU 34
          RETMGU 35
        TRADEBGU 36
          UNWCGU 37
        SP1M3YGU 38
        SP1UNCGU 39
        SP2M3YGU 40

OTHER:
        OILPRICE 41    oil prices
            NBER 42	NBER recession dummy
*/


/* cleaning the data */
? "cleaning the data";

i_isus  = 7;
i_ilus  = 8;
i_smus  = 10;
i_isge  = 5;
i_ilge  = 6;
i_smge  = 11;   
i_usge  = 9;
i_cont  = 41|seqa(12,1,14)|seqa(26,1,15);
i_nber  = 42;


if metodotim eq 1;
    i_cont  = 41;
elseif metodotim eq 2;
    i_cont  = i_cont|i_nber;
elseif metodotim eq 3;
    i_cont  = 41|i_nber;
endif;




DataCol = 4;
if (metodotim eq 1) or (metodotim eq 3);
    /* cleaning the time periods */
    prov = ECBData[.,2]*10000+ECBData[.,3]*100+ECBData[.,4];
    prov = (prov.>=winini).*(prov.<=winfin);
    prov = miss(prov,0);

    ECBData[.,DataCol:cols(ECBData)] = ECBData[.,DataCol:cols(ECBData)].*prov;
endif;

Data = ECBData[.,1:DataCol];
Data = Data~(Data[.,2]*10000+Data[.,3]*100+Data[.,4]);

DataCol = DataCol+1;
Data = Data~ECBData[.,i_isus i_ilus i_smus i_isge i_ilge i_smge i_usge];
Data = Data~ECBData[.,i_cont];
Data = packr(Data);

DataOri = Data;

/* computing the two day returns to eliminate the problems with the non-syncronous trading */

    /* we only change our variables of interest */
    /* interest rates in levels */
    if metodoint eq 1;    
        if metodoret eq 1;
            i=rows(Data); do while i ge 2;
                t=DataCol+1;
                Data[i,t] = Data[i,t]/100;                                              t=t+1;
                Data[i,t] = Data[i,t]/100;                                              t=t+1;
                Data[i,t] = (Data[i,t]/Data[i-1,t])^(1/(Data[i,1]-Data[i-1,1])) - 1;    t=t+1;
                Data[i,t] = Data[i,t]/100;                                              t=t+1;
                Data[i,t] = Data[i,t]/100;                                              t=t+1;
                Data[i,t] = (Data[i,t]/Data[i-1,t])^(1/(Data[i,1]-Data[i-1,1])) - 1;    t=t+1;
                Data[i,t] = (Data[i,t]/Data[i-1,t])^(1/(Data[i,1]-Data[i-1,1])) - 1;    t=t+1;

                Data[i,t] = (Data[i,t]/Data[i-1,t])^(1/(Data[i,1]-Data[i-1,1])) - 1;    t=t+1;
            i=i-1; endo;
            Data = trimr(Data,1,0);
        else;
            i=rows(Data); do while i ge metodoret+1;
                t=DataCol+1;
                Data[i,t] = sumc(Data[i:i-metodoret+1,t])/(metodoret*100);                              t=t+1;
                Data[i,t] = sumc(Data[i:i-metodoret+1,t])/(metodoret*100);                              t=t+1;
                Data[i,t] = ((Data[i,t]/Data[i-metodoret,t])^(1/(Data[i,1]-Data[i-metodoret,1])))-1;    t=t+1;
                Data[i,t] = sumc(Data[i:i-metodoret+1,t])/(metodoret*100);                              t=t+1;
                Data[i,t] = sumc(Data[i:i-metodoret+1,t])/(metodoret*100);                              t=t+1;
                Data[i,t] = ((Data[i,t]/Data[i-metodoret,t])^(1/(Data[i,1]-Data[i-metodoret,1])))-1;    t=t+1;
                Data[i,t] = ((Data[i,t]/Data[i-metodoret,t])^(1/(Data[i,1]-Data[i-metodoret,1])))-1;    t=t+1;

                Data[i,t] = ((Data[i,t]/Data[i-metodoret,t])^(1/(Data[i,1]-Data[i-metodoret,1])))-1;    t=t+1;

                if t le cols(Data);
                    Data[i,t:cols(Data)] = sumc(Data[i:i-metodoret+1,t:cols(Data)])';
                endif;
            i=i-1; endo;
            
    
            Data_e = seqa(1,1,rows(Data))/metodoret;
            Data_e = 1-((Data_e-trunc(Data_e)).>0);
            Data_e = miss(Data_e,0);
            Data_e = packr(Data.*Data_e);
            Data   = trimr(Data_e,2,0);
        endif;

    
    /* interest rates in first differences */
    elseif metodoint eq 2;
        if metodoret eq 1;
            i=rows(Data); do while i ge 2;
                t=DataCol+1;
                Data[i,t] = (Data[i,t]-Data[i-1,t])/100;                                              t=t+1;
                Data[i,t] = (Data[i,t]-Data[i-1,t])/100;                                              t=t+1;
                Data[i,t] = (Data[i,t]/Data[i-1,t])^(1/(Data[i,1]-Data[i-1,1])) - 1;                  t=t+1;
                Data[i,t] = (Data[i,t]-Data[i-1,t])/100;                                              t=t+1;
                Data[i,t] = (Data[i,t]-Data[i-1,t])/100;                                              t=t+1;
                Data[i,t] = (Data[i,t]/Data[i-1,t])^(1/(Data[i,1]-Data[i-1,1])) - 1;                  t=t+1;
                Data[i,t] = (Data[i,t]/Data[i-1,t])^(1/(Data[i,1]-Data[i-1,1])) - 1;                  t=t+1;

                Data[i,t] = (Data[i,t]/Data[i-1,t])^(1/(Data[i,1]-Data[i-1,1])) - 1;    t=t+1;
            i=i-1; endo;
            Data = trimr(Data,1,0);
        else;
            i=rows(Data); do while i ge metodoret+1;
                t=DataCol+1;
                Data[i,t] = (sumc(Data[i:i-metodoret+1,t])-sumc(Data[i-1:i-metodoret,t]))/(100);        t=t+1;
                Data[i,t] = (sumc(Data[i:i-metodoret+1,t])-sumc(Data[i-1:i-metodoret,t]))/(100);        t=t+1;
                Data[i,t] = ((Data[i,t]/Data[i-metodoret,t])^(1/(Data[i,1]-Data[i-metodoret,1])))-1;    t=t+1;
                Data[i,t] = (sumc(Data[i:i-metodoret+1,t])-sumc(Data[i-1:i-metodoret,t]))/(100);        t=t+1;
                Data[i,t] = (sumc(Data[i:i-metodoret+1,t])-sumc(Data[i-1:i-metodoret,t]))/(100);        t=t+1;
                Data[i,t] = ((Data[i,t]/Data[i-metodoret,t])^(1/(Data[i,1]-Data[i-metodoret,1])))-1;    t=t+1;
                Data[i,t] = ((Data[i,t]/Data[i-metodoret,t])^(1/(Data[i,1]-Data[i-metodoret,1])))-1;    t=t+1;

                Data[i,t] = ((Data[i,t]/Data[i-metodoret,t])^(1/(Data[i,1]-Data[i-metodoret,1])))-1;    t=t+1;

                if t le cols(Data);
                    Data[i,t:cols(Data)] = sumc(Data[i:i-metodoret+1,t:cols(Data)])';
                endif;
            i=i-1; endo;
            
    
            Data_e = seqa(1,1,rows(Data))/metodoret;
            Data_e = 1-((Data_e-trunc(Data_e)).>0);
            Data_e = miss(Data_e,0);
            Data_e = packr(Data.*Data_e);
            Data   = trimr(Data_e,2,0);
        endif;
    
    
    /* long run interest rates in yields */
    elseif metodoint eq 3;
        if metodoret eq 1;
            i=rows(Data); do while i ge 2;
                t=DataCol+1;
                Data[i,t] = Data[i,t]/100;                                              t=t+1;
                Data[i,t] = Data[i,t]/100 - Data[i,t-1];                                t=t+1;
                Data[i,t] = (Data[i,t]/Data[i-1,t])^(1/(Data[i,1]-Data[i-1,1])) - 1;    t=t+1;
                Data[i,t] = Data[i,t]/100;                                              t=t+1;
                Data[i,t] = Data[i,t]/100 - Data[i,t-1];                                t=t+1;
                Data[i,t] = (Data[i,t]/Data[i-1,t])^(1/(Data[i,1]-Data[i-1,1])) - 1;    t=t+1;
                Data[i,t] = (Data[i,t]/Data[i-1,t])^(1/(Data[i,1]-Data[i-1,1])) - 1;    t=t+1;

                Data[i,t] = (Data[i,t]/Data[i-1,t])^(1/(Data[i,1]-Data[i-1,1])) - 1;    t=t+1;
            i=i-1; endo;
            Data = trimr(Data,1,0);
        else;
            i=rows(Data); do while i ge metodoret+1;
                t=DataCol+1;
                Data[i,t] = sumc(Data[i:i-metodoret+1,t])/(metodoret*100);                              t=t+1;
                Data[i,t] = sumc(Data[i:i-metodoret+1,t])/(metodoret*100) - Data[i,t-1];                t=t+1;
                Data[i,t] = ((Data[i,t]/Data[i-metodoret,t])^(1/(Data[i,1]-Data[i-metodoret,1])))-1;    t=t+1;
                Data[i,t] = sumc(Data[i:i-metodoret+1,t])/(metodoret*100);                              t=t+1;
                Data[i,t] = sumc(Data[i:i-metodoret+1,t])/(metodoret*100) - Data[i,t-1];                t=t+1;
                Data[i,t] = ((Data[i,t]/Data[i-metodoret,t])^(1/(Data[i,1]-Data[i-metodoret,1])))-1;    t=t+1;
                Data[i,t] = ((Data[i,t]/Data[i-metodoret,t])^(1/(Data[i,1]-Data[i-metodoret,1])))-1;    t=t+1;

                Data[i,t] = ((Data[i,t]/Data[i-metodoret,t])^(1/(Data[i,1]-Data[i-metodoret,1])))-1;    t=t+1;

                if t le cols(Data);
                    Data[i,t:cols(Data)] = sumc(Data[i:i-metodoret+1,t:cols(Data)])';
                endif;
            i=i-1; endo;
            
    
            Data_e = seqa(1,1,rows(Data))/metodoret;
            Data_e = 1-((Data_e-trunc(Data_e)).>0);
            Data_e = miss(Data_e,0);
            Data_e = packr(Data.*Data_e);
            Data   = trimr(Data_e,2,0);
        endif;
    
    
    /* interest rates in first differences and long rates in yields */
    elseif metodoint eq 4;
        if metodoret eq 1;
            i=rows(Data); do while i ge 2;
                t=DataCol+1;
                Data[i,t] = (Data[i,t]-Data[i-1,t])/100;                                              t=t+1;
                Data[i,t] = (Data[i,t]-Data[i-1,t])/100 - Data[i,t-1];                                t=t+1;
                Data[i,t] = (Data[i,t]/Data[i-1,t])^(1/(Data[i,1]-Data[i-1,1])) - 1;                  t=t+1;
                Data[i,t] = (Data[i,t]-Data[i-1,t])/100;                                              t=t+1;
                Data[i,t] = (Data[i,t]-Data[i-1,t])/100 - Data[i,t-1];                                t=t+1;
                Data[i,t] = (Data[i,t]/Data[i-1,t])^(1/(Data[i,1]-Data[i-1,1])) - 1;                  t=t+1;
                Data[i,t] = (Data[i,t]/Data[i-1,t])^(1/(Data[i,1]-Data[i-1,1])) - 1;                  t=t+1;

                Data[i,t] = (Data[i,t]/Data[i-1,t])^(1/(Data[i,1]-Data[i-1,1])) - 1;                  t=t+1;
            i=i-1; endo;
            Data = trimr(Data,1,0);
        else;
            i=rows(Data); do while i ge metodoret+1;
                t=DataCol+1;
                Data[i,t] = (sumc(Data[i:i-metodoret+1,t])-sumc(Data[i-1:i-metodoret,t]))/(100);                t=t+1;
                Data[i,t] = (sumc(Data[i:i-metodoret+1,t])-sumc(Data[i-1:i-metodoret,t]))/(100) - Data[i,t-1];  t=t+1;
                Data[i,t] = ((Data[i,t]/Data[i-metodoret,t])^(1/(Data[i,1]-Data[i-metodoret,1])))-1;            t=t+1;
                Data[i,t] = (sumc(Data[i:i-metodoret+1,t])-sumc(Data[i-1:i-metodoret,t]))/(100);                t=t+1;
                Data[i,t] = (sumc(Data[i:i-metodoret+1,t])-sumc(Data[i-1:i-metodoret,t]))/(100) - Data[i,t-1];  t=t+1;
                Data[i,t] = ((Data[i,t]/Data[i-metodoret,t])^(1/(Data[i,1]-Data[i-metodoret,1])))-1;            t=t+1;
                Data[i,t] = ((Data[i,t]/Data[i-metodoret,t])^(1/(Data[i,1]-Data[i-metodoret,1])))-1;            t=t+1;

                Data[i,t] = ((Data[i,t]/Data[i-metodoret,t])^(1/(Data[i,1]-Data[i-metodoret,1])))-1;    t=t+1;

                if t le cols(Data);
                    Data[i,t:cols(Data)] = sumc(Data[i:i-metodoret+1,t:cols(Data)])';
                endif;
            i=i-1; endo;
            
    
            Data_e = seqa(1,1,rows(Data))/metodoret;
            Data_e = 1-((Data_e-trunc(Data_e)).>0);
            Data_e = miss(Data_e,0);
            Data_e = packr(Data.*Data_e);
            Data   = trimr(Data_e,2,0);
        endif;
    
    
    
    else;
        stop;
    endif;



    /************************/
    /************************/
    /*                      */
    /*                      */
    /*     ESTIMATION       */
    /*                      */
    /*                      */
    /************************/
    /************************/




    /* running the VAR and cleaning the means */
        ? "VAR";    


            /* we have to eliminate the nber date)s from the estimation. we put missing values */
            if (metodotim eq 2) or (metodotim eq 3);
                NBERDum = miss(1-(trimr(Data[.,cols(Data)],lags,0).>0),0);
            else;
                NBERDum = 1;
            endif;

            
            if metodovar eq 1;
                x = Data[.,DataCol+1:cols(Data)];
        
                xx = ones(rows(x),1)~seqa(1,1,rows(x))/rows(x);
                i=1; do while i le lags;
                    xx = xx~lagn(x,-(lags-i));
                i=i+1; endo;
                yy = lagn(x[.,1:7],-lags);
                xx = xx~lagn(x[.,8:cols(x)],-lags);
        
                yy = trimr(yy,0,lags);
                xx = trimr(xx,0,lags);
                dd = trimr(Data[.,1:DataCol],lags,0);
        
                beta_rf = inv(xx'xx)*(xx'yy);
                resi_rf = yy-xx*beta_rf;
                        
                Data = dd~resi_rf;
            endif;





    /* normalizing */
        ? "normalization";
            if metodonor eq 0;
                DataNorm = ones(1,DataCol)~(sqrt(diag(vcx(resi_rf)))'/100);
                Data     = Data./DataNorm;
            elseif metodonor eq 1;
                DataNorm = ones(1,DataCol)~0.0001*ones(1,cols(resi_rf));
                Data     = Data./DataNorm;
            elseif metodonor eq 2;
                DataNorm = ones(1,DataCol)~0.01*ones(1,cols(resi_rf));
                Data     = Data./DataNorm;
            else;
                stop;
            endif;    


        

    /* rolling window of second moments */
        ? "creating the regimes";
            Data = Data.*NBERDum;
            DataRoll = ones(win,1)*sqrt(diag(vcx(packr(Data[.,DataCol+1:Cols(Data)]))))';
            i=win+1; do while i le rows(Data);
                DataRoll = DataRoll | sqrt(diag(vcx(Data[i:i-win,DataCol+1:Cols(Data)])))';
            i=i+1; endo;

            Data     = Data.*miss(1-(missrv(DataRoll[.,1],nulo).==nulo),0);

            Data     = packr(Data);
            DataRoll = packr(DataRoll);

            DataWind = DataRoll[1,.]+limit*sqrt(diag(vcx(DataRoll)))';
            DataWind = (DataRoll.>DataWind);
            ? rows(data)~rows(dataroll);
            

            /* finding the observations that are always in low variance */
            DataProv = 1;
            i=1; do while i le cols(DataWind);
                DataProv = DataProv.*(1-DataWind[.,i]);
            i=i+1; endo;
            DataReg = DataProv;



    if metodoreg eq 0;
            /* finding feasible unique regimes of high volatility for each variable */
            i=1; do while i le cols(DataWind);
                DataProv = 1;
                j=1; do while j le cols(DataWind);
                    if j eq i;
                        DataProv = DataProv.*DataWind[.,j];
                    else;
                        DataProv = DataProv.*(1-DataWind[.,j]);
                    endif;
                j=j+1; endo;

                if sumc(DataProv) gt minobs;
                    DataReg  = DataReg~DataProv;
                else;
                    DataReg  = DataReg~DataWind[.,i];
                endif;
            i=i+1; endo;

    else;
            /* finding all the other permutations of high volatility */
            n = 7;
            DataMask = seqa(0,1,2^n);
            DataProv = DataMask;
            i=1; do while i le n;
                DataMask = DataMask~( int(DataProv./(2^(n-i))) );
                DataProv = DataProv-(2^(n-i))*( int(DataProv[.,1]./(2^(n-i))) );
            i=i+1; endo;
            DataMask = DataMask[.,2:n+1];


            i=2; do while i le rows(DataMask);
                DataProv = 1;
                j=1; do while j le cols(DataMask);
                    if DataMask[i,j] eq 1;
                        DataProv = DataProv.*DataWind[.,j];
                    else;
                        DataProv = DataProv.*(1-DataWind[.,j]);
                    endif;
                j=j+1; endo;

                if sumc(DataProv) gt minobs;
                    DataReg  = DataReg~DataProv;
                endif;
            i=i+1; endo;
    endif;







/**************************************************/        
/**************************************************/        
/*                                                */        
/*                                                */        
/*       INITIALIZATION FOR ESTIMATION            */
/*                                                */        
/*                                                */        
/**************************************************/        
/**************************************************/        
    /* preparing the data for the GMM */
        ? "estimation";
            DataGMM = Data[.,DataCol+1:cols(Data)];
            DataReg = DataReg;

            gmmvar = rows(DataGMM)|diag(vcx(DataGMM));
            i=1; do while i le cols(DataReg);
                gmmprov = packr(DataGMM.*miss(DataReg[.,i],0));
                gmmvar  = gmmvar~(rows(gmmprov)|diag(vcx(gmmprov)));
            i=i+1; endo;
            gmmvar[2:rows(gmmvar),.] = gmmvar[2:rows(gmmvar),.]./gmmvar[2:rows(gmmvar),2];
            gmmvar = gmmvar[.,2:cols(gmmvar)];

            output file=^Archivo on;
                ? "Covariance matrix of the regimes";
                ? gmmvar;
            output off;


    if metodoA eq 0;


            A_rest  =   99 ~  -1  ~  0  ~  -11 ~  90   ~  90   ~   0   |
                        0  ~  99  ~  0   ~  90   ~  -11 ~  90   ~   0   |
                        1  ~  1   ~  99  ~  90   ~  90   ~  10 ~   0   |
                        -11~  90   ~  90   ~  99  ~  -1  ~  0  ~   0   |
                        90  ~  -11 ~  90   ~  0   ~  99  ~  0   ~   0   |
                        90  ~  90   ~  10 ~  1   ~  1   ~  99  ~   0   |
                        0  ~  1   ~  0   ~  0   ~  -1   ~  0   ~   99  ;     


            A_para  =   0  ~  0   ~  0   ~   0  ~   0  ~   0  ~   0   |
                        0  ~  0   ~  0   ~   0  ~   0  ~   0  ~   0   |          
                        0  ~  0   ~  0   ~   0  ~   0  ~   0  ~   0   |
                        0  ~  0   ~  0   ~   0  ~   0  ~   0  ~   0   |
                        0  ~  0   ~  0   ~   0  ~   0  ~   0  ~   0   |
                        0  ~  0   ~  0   ~   0  ~   0  ~   0  ~   0   |
                        0  ~  0   ~  0   ~   0  ~   0  ~   0  ~   0   ;


            A_redd  =   1  ~  1   ~  0   ~   1  ~   0  ~   0  ~   0   |
                        0  ~  1   ~  0   ~   0  ~   1  ~   0  ~   0   |          
                        -1 ~  -1  ~  1   ~   0  ~   0  ~   0  ~   0   |
                        81 ~  0   ~  0   ~   1  ~   1  ~   0  ~   0   |
                        0  ~  81   ~  0   ~   0  ~   1  ~   0  ~   0   |
                        0  ~  0   ~  81  ~   -1 ~   -1 ~   1  ~   0   |
                        0  ~  0   ~  0   ~   0  ~   0  ~   0  ~   1   ;


            A_redp  =   0  ~  0   ~  0   ~   0  ~   0  ~   0  ~   0   |
                        0  ~  0   ~  0   ~   0  ~   0  ~   0  ~   0   |          
                        0  ~  0   ~  0   ~   0  ~   0  ~   0  ~   0   |
                        104~  0   ~  0   ~   0  ~   0  ~   0  ~   0   |
                        0  ~  205 ~  0   ~   0  ~   0  ~   0  ~   0   |
                        0  ~  0   ~  306 ~   0  ~   0  ~   0  ~   0   |
                        0  ~  0   ~  0   ~   0  ~   0  ~   0  ~   0   ;


    else;
        ? "PROBLEM (in german)";
        stop;
    endif;





    DataVCX = 0;
    i=1; do while i le cols(DataReg);
        gmmprov = packr(DataGMM.*miss(DataReg[.,i],0));
        gmmprov = vech(vcx(gmmprov));

        if DataVCX eq 0;
            DataVCX = gmmprov;
        else;
            DataVCX = DataVCX~gmmprov;
        endif;
    i=i+1; endo;














/********************************/
/*                              */
/*          ESTIMATION          */
/*                              */
/********************************/

/* initializing the parameters */    
        n                                = cols(DataGMM);
        A                                = ones(n,n);
        {A,gama,sigzreg,param_o,param_b} = parametros(A,A_rest,param_o,n,0);

        _cml_Algorithm  = 1;
        _cml_Bounds     = param_b;
        _cml_LineSearch = 2;
        _cml_Covpar     = 1;
        _cml_MaxIters   = 300;
            
        if metodored eq 0;
            if metodocom eq 0;
                {p_x,p_f,p_g,p_c,p_r} = cmlprt(cml(DataGMM,0,&FindARegimes,param_o));
                stop;



            else;
                metodocom = 0;
                {A,gama,sigzreg,param_o,param_b} = parametros(A,A_rest,param_o,n,0);

                    _cml_Bounds     = param_b;
                        {p_x,p_f,p_g,p_c,p_r} = cmlprt(cml(DataGMM,0,&FindARegimes,param_o));
    
                metodocom = 2;
                {A,gama,sigzreg,param_o,param_b} = parametros(A,A_rest,param_o,n,0);
                param_o[1:rows(p_x)] = p_x;

                    _cml_Bounds     = param_b;
                    _cml_MaxIters   = 100;
                        {p_x,p_f,p_g,p_c,p_r} = cmlprt(cml(DataGMM,0,&FindARegimes,param_o));

                metodocom = 1;
                {A,gama,sigzreg,param_o,param_b} = parametros(A,A_rest,param_o,n,0);
                param_o = p_x;

                    _cml_Bounds     = param_b;
                    _cml_MaxIters   = 300;
                        {p_x,p_f,p_g,p_c,p_r} = cmlprt(cml(DataGMM,0,&FindARegimes,param_o));


                    
            endif;





        elseif metodored eq 1;
            ? "running only the A";
            metodored = 0;
            metodocom = 0;
            {A,gama,sigzreg,param_o,param_b} = parametros(A,A_rest,param_o,n,0);

                _cml_Bounds     = param_b;
                _cml_DirTol     = 0.00001;
                    {p_x,p_f,p_g,p_c,p_r} = cmlprt(cml(DataGMM,0,&FindARegimes,param_o));

            metodocom = 2;
            {A,gama,sigzreg,param_o,param_b} = parametros(A,A_rest,param_o,n,0);
            param_o[1:rows(p_x)] = p_x;

                _cml_Bounds     = param_b;
                _cml_MaxIters   = 100;
                _cml_DirTol     = 0.0001;
                    {p_x,p_f,p_g,p_c,p_r} = cmlprt(cml(DataGMM,0,&FindARegimes,param_o));

            /* ? "hola"; wait; */
            metodored = 1;
            metodocom = 1;
            {A,gama,sigzreg,param_o,param_b} = parametros(A,A_rest,param_o,n,0);
            param_o = p_x;

                _cml_Bounds     = param_b;
                _cml_MaxIters   = 300;
                _cml_DirTol     = 0.001;
                _cml_LineSearch = 3;
                    {p_x,p_f,p_g,p_c,p_r} = cmlprt(cml(DataGMM,0,&FindARegimes,param_o));




            /* estimating the variance decomposition */
                DataVCX_orig = DataVCX;
                GMMvar_orig  = GMMvar;
                p_x_orig     = p_x;
                A_orig = A;
                {A,gama,sigZreg,p_x,param_b} = parametros(A,A_rest,p_x_orig,n,1);
           
                vardecomp = zeros(n,n);
                sigEunc   = zeros(n,n);
                sigZunc   = 0;
                i=1; do while i le cols(DataVCX);
                    prov = xpnd(DataVCX[.,i]);
                    prov = A * prov * A';
                    prov = prov - (gama*gama' * sigZreg[i]);
                    sigEreg = diagrv(eye(n),diag(prov));

                    vardecomp = vardecomp + xpnd(DataVCX[.,i])*GMMvar[1,i]/sumc(GMMvar[1,.]');
                    sigEunc   = sigEunc   + sigEreg           *GMMvar[1,i]/sumc(GMMvar[1,.]');
                    sigZunc   = sigZunc   + sigZreg[i]        *GMMvar[1,i]/sumc(GMMvar[1,.]');
                i=i+1; endo;

                vardecomp = diag(vardecomp);
                invA      = inv(A);
                i=1; do while i le n;
                    sigE      = zeros(n,n);
                    sigE[i,i] = 1;
                    sigE      = sigE.*sigEunc;
                    sigE      = invA*sigE*invA';
                    vardecomp = vardecomp~diag(sigE);    
                i=i+1; endo;                    
                sigz      = gama*sigZunc*gama';
                sigz      = invA*sigz*invA';
                vardecomp = vardecomp~diag(sigz); 
                vardecomp = vardecomp~sumc(vardecomp[.,2:2+n]');   
                xxt = vardecomp'./vardecomp[.,cols(vardecomp)]';
                vdec=xxt[2:9,1:7];

                vdec_orig     = vdec;


            cls; 
            if boot eq 0;
            else;
                ? "Now we estimate the bootstrap";

            
                p_boot = p_x;
                a_boot = vec(inv(A));
                vdec_boot = vec(vdec);
                bb_boot=1; do while bb_boot le boot;
                    /* creating new covariance matrices for each regime*/
                    i=1; do while i le cols(DataVCX_orig);
                        prov = chol(xpnd(DataVCX_orig[.,i]))';
                        prov = prov*rndn(n,GMMvar[1,i]);
                        DataVCX[.,i] = vech(vcx(prov'));
                    i=i+1; endo;

                        {p_x,p_f,p_g,p_c,p_r} = cmlprt(cml(DataGMM,0,&FindARegimes,p_x_orig));
                            p_boot = p_boot~p_x;
                            a_boot = a_boot~vec(inv(A));

                vardecomp = zeros(n,n);
                sigEunc   = zeros(n,n);
                sigZunc   = 0;
                i=1; do while i le cols(DataVCX);
                    prov = xpnd(DataVCX[.,i]);
                    prov = A * prov * A';
                    prov = prov - (gama*gama' * sigZreg[i]);
                    sigEreg = diagrv(eye(n),diag(prov));

                    vardecomp = vardecomp + xpnd(DataVCX[.,i])*GMMvar[1,i]/sumc(GMMvar[1,.]');
                    sigEunc   = sigEunc   + sigEreg           *GMMvar[1,i]/sumc(GMMvar[1,.]');
                    sigZunc   = sigZunc   + sigZreg[i]        *GMMvar[1,i]/sumc(GMMvar[1,.]');
                i=i+1; endo;

                vardecomp = diag(vardecomp);
                invA      = inv(A);
                i=1; do while i le n;
                    sigE      = zeros(n,n);
                    sigE[i,i] = 1;
                    sigE      = sigE.*sigEunc;
                    sigE      = invA*sigE*invA';
                    vardecomp = vardecomp~diag(sigE);    
                i=i+1; endo;                    
                sigz      = gama*sigZunc*gama';
                sigz      = invA*sigz*invA';
                vardecomp = vardecomp~diag(sigz); 
                vardecomp = vardecomp~sumc(vardecomp[.,2:2+n]');   
                xxt = vardecomp'./vardecomp[.,cols(vardecomp)]';
                vdec=xxt[2:9,1:7];
                            vdec_boot = vdec_boot~vec(vdec);

                            cls;
                bb_boot=bb_boot+1; endo;
            endif;
        else;
            ? "problems with metodored"; stop;
        endif;  








/* PRINTING */


output file=^Archivo on; 
    ? "Our beatiful matrix A";

    ? A_orig;
    ? ;
    ? "and the inverse";
    ? inv(A_orig);

    ?; ?; ?; ?;

    ? "Variance dcomposition";
/*    ? vardecomp'; */

    ? vdec_orig;
    ?; ?; ?; ?;

output off;


p_boot_stat = p_boot[.,1]';
p_boot_stat = p_boot_stat|sumc(p_boot')'/(boot+1);
p_boot_stat = p_boot_stat|sqrt(diag(vcx(p_boot')))';
p_boot_stat = p_boot_stat|maxc(p_boot')';
p_boot_stat = p_boot_stat|minc(p_boot')';
p_boot_stat = p_boot_stat|sumc(p_boot'.>0)'/(boot+1);
p_boot_stat = p_boot_stat|sumc(abs(p_boot)'.<0.00001)'/(boot+1);
p_boot_stat = p_boot_stat|sumc(abs(p_boot+1)'.<0.00001)'/(boot+1);

p_boot_min  = int(minc(p_boot')*100)'/100;
p_boot_max  = int(maxc(p_boot')*100+1)'/100;
p_boot_ste  = (p_boot_max-p_boot_min)/(dist-1);
p_boot_dis  = p_boot_min*0;
p_boot_mas  = p_boot_min*0;
i=1; do while i le dist+1;
    p_boot_tre = p_boot_min + (i-1)*p_boot_ste;
    p_boot_mas = p_boot_mas | sumc(p_boot'.<p_boot_tre)';
    p_boot_dis = p_boot_dis | p_boot_tre;
i=i+1; endo;
p_boot_stat = p_boot_stat | p_boot_mas|p_boot_dis;


a_boot_stat = a_boot[.,1]';
a_boot_stat = a_boot_stat|sumc(a_boot')'/(boot+1);
a_boot_stat = a_boot_stat|sqrt(diag(vcx(a_boot')))';
a_boot_stat = a_boot_stat|maxc(a_boot')';
a_boot_stat = a_boot_stat|minc(a_boot')';
a_boot_stat = a_boot_stat|sumc(a_boot'.>0)'/(boot+1);
a_boot_stat = a_boot_stat|sumc(abs(a_boot)'.<0.00001)'/(boot+1);
a_boot_stat = a_boot_stat|sumc(abs(a_boot+1)'.<0.00001)'/(boot+1);

a_boot_min  = int(minc(a_boot')*100)'/100;
a_boot_max  = int(maxc(a_boot')*100+1)'/100;
a_boot_ste  = (a_boot_max-a_boot_min)/(dist-1);
a_boot_dis  = a_boot_min*0;
a_boot_mas  = a_boot_min*0;
i=1; do while i le dist+1;
    a_boot_tre = a_boot_min + (i-1)*a_boot_ste;
    a_boot_mas = a_boot_mas | sumc(a_boot'.<a_boot_tre)';
    a_boot_dis = a_boot_dis | a_boot_tre;
i=i+1; endo;
a_boot_stat = a_boot_stat | a_boot_mas|a_boot_dis;



xlswritem(p_boot',ArchXLS, "b2", 1, 0);
xlswritem(a_boot',ArchXLS, "b2", 2, 0);
xlswritem(p_boot_stat,ArchXLS, "b2", 3, 0);
xlswritem(a_boot_stat,ArchXLS, "b2", 4, 0);
xlswritem(A_orig,ArchXLS, "b2", 5, 0);
xlswritem(inv(A_orig),ArchXLS, "b10", 5, 0);
xlswritem(vdec_orig,ArchXLS, "b18", 5, 0);
xlswritem(vdec_boot',ArchXLS, "b2", 6, 0);


/*clear A; clear a_boot; clear a_boot_dis; clear a_boot_mas; clear a_boot_max; clear a_boot_min; clear a_boot_stat; clear a_boot_ste; clear a_boot_tre; clear A_orig; clear A_para; clear A_redd; clear A_redp; clear A_rest; clear bb_boot; clear beta_rf; clear boot; clear d; clear Data; clear Data_e; clear DataCol; clear DataGMM; clear DataMask; clear DataNorm; clear DataOri; clear DataProv; clear DataReg; clear DataRoll; clear datatype; clear DataVCX; clear DataVCX_orig; clear DataWind; clear dd; clear dist; clear ECBData; clear gama; clear gmm; clear gmmpen; clear gmmprov; clear gmmvar; clear GMMvar_orig; clear gmmvcx; clear gmo; clear gmp; clear i; clear i_cont; clear i_ilge; clear i_ilus; clear i_isge; clear i_isus; clear i_nber; clear i_smge; clear i_smus; clear i_usge; clear invA; clear j; clear k; clear lags; clear leer; clear limit; clear metodoA; clear metodocom; clear metodoint; clear metodonor; clear metodored; clear metodoreg; clear metodoret; clear metodotim; clear metodovar; clear minobs; clear n; clear NBERDum; clear nulo; clear p_boot; clear p_boot_dis; clear p_boot_mas; clear p_boot_max; clear p_boot_min; clear p_boot_stat; clear p_boot_ste; clear p_boot_tre; clear p_c; clear p_f; clear p_g; clear p_r; clear p_x; clear p_x_orig; clear param_b; clear param_o; clear penalty; clear prov; clear resi_rf; clear sigE; clear sigEreg; clear sigEunc; clear sigz; clear sigzreg; clear sigZunc; clear t; clear v; clear vardecomp; clear vdec; clear vdec_boot; clear vdec_orig; clear win; clear winfin; clear winini; clear x; clear xx; clear xxt; clear yy;*/
stop;






/********************/
/********************/
/*                  */
/*    PROCEDURES    */
/*                  */
/********************/
/********************/


proc (5)=parametros(A,A_rest,param,n,dir);
    local i,j,plim,plimvar,t,A_std,Sigma_std,param_c,cmle,xi,xj,param_b,gama, sigZreg;
    
    cmle = 0;
    plim = 100;
    plimvar = 1000000000;


    /* this initializes all the variables using n (number of regimes) and A_ret */
    if dir eq 0;
        A = zeros(n,n);
        t=1; 
        param_o = 0;
        param_b = 0~0;
        i=1; do while i le n;
            j=1; do while j le n;
                if A_rest[i,j] eq 0;
                    param_o = param_o|0.005; t=t+1;
                    param_b = param_b|-plim~plim;
                elseif A_rest[i,j] eq 1;
                    param_o = param_o|0.01; t=t+1;
                    param_b = param_b|0~plim;
                elseif A_rest[i,j] eq -1;
                    param_o = param_o|-0.01; t=t+1;
                    param_b = param_b|-plim~0;

                elseif A_rest[i,j] eq 10;
                    param_o = param_o|0.005; t=t+1;
                    param_b = param_b|-1~1;
                elseif A_rest[i,j] eq 11;
                    param_o = param_o|0.01; t=t+1;
                    param_b = param_b|0~1;
                elseif A_rest[i,j] eq -11;
                    param_o = param_o|-0.01; t=t+1;
                    param_b = param_b|-1~0;

                elseif A_rest[i,j] eq 50;
                    param_o = param_o|0.005; t=t+1;
                    param_b = param_b|-plim~plim;

                elseif A_rest[i,j] eq 60;
                    param_o = param_o|-0.01; t=t+1;
                    param_b = param_b|-plim~plim;

                elseif A_rest[i,j] eq 80;
                elseif A_rest[i,j] eq 81;
                    param_o = param_o|0.01; t=t+1;
                    param_b = param_b|0~1;
                elseif A_rest[i,j] eq -81;
                    param_o = param_o|-0.01; t=t+1;
                    param_b = param_b|-1~0;

                elseif A_rest[i,j] eq 90;
                elseif A_rest[i,j] eq 99;
                    a[i,j] = 1;
                else;
                    ? "PROBLEM"; stop;
                endif;                            
            j=j+1; endo;
        i=i+1; endo;
        param_o = trimr(param_o,1,0);
        param_b = trimr(param_b,1,0);


        if metodocom eq 0;
            gama = 0;
            sigZreg = 0;
        else;
            gama    = 1*ones(n-1,1);
            sigZreg = 1*ones(cols(datareg),1);
            param_o = param_o|gama;
            param_b = param_b| -plim*ones(rows(gama),1)~plim*ones(rows(gama),1);
    
            param_o = param_o|sigZreg;
            param_b = param_b| zeros(rows(sigZreg),1)~plimvar*ones(rows(sigZreg),1);
        endif;


        retp(A,gama,sigZreg,param_o,param_b);   








    /* changes from param to A */
    elseif dir eq 1;
        t=1;
        A = A_rest*0;
        param_b = miss(A*0,0);
        i=1; do while i le cols(A_rest);
            j=1; do while j le rows(A_rest);
                if A_rest[i,j] eq 0;
                    A[i,j]  = param[t]; t=t+1;
                elseif A_rest[i,j] eq 1;
                    A[i,j]  = param[t]; t=t+1;
                elseif A_rest[i,j] eq -1;
                    A[i,j]  = param[t]; t=t+1;

                elseif A_rest[i,j] eq 10;
                    A[i,j]  = param[t]; t=t+1;
                elseif A_rest[i,j] eq 11;
                    A[i,j]  = param[t]; t=t+1;
                elseif A_rest[i,j] eq -11;
                    A[i,j]  = param[t]; t=t+1;


                elseif A_rest[i,j] eq 50;
                        A[i,j]  = 0; t=t+1;
                elseif A_rest[i,j] eq 60;
                        A[i,j]  = 0; t=t+1;
                elseif A_rest[i,j] eq 80;
                elseif A_rest[i,j] eq 81;
                    A[i,j]  = 0; t=t+1;
                elseif A_rest[i,j] eq -81;
                    A[i,j]  = 0; t=t+1;


                elseif A_rest[i,j] eq 90;
                    A[i,j]  = 0;
                elseif A_rest[i,j] eq 99;
                    A[i,j]  = 1;
                else;
                    ? "in parametros";
                    stop;
                endif;
            j=j+1; endo;
        i=i+1; endo;

        t=1;
        param_b = miss(A*0,0);
        i=1; do while i le cols(A_rest);
            j=1; do while j le rows(A_rest);
                if A_rest[i,j] eq 0;
                    A[i,j]  = param[t]; t=t+1;
                elseif A_rest[i,j] eq 1;
                    A[i,j]  = param[t]; t=t+1;
                elseif A_rest[i,j] eq -1;
                    A[i,j]  = param[t]; t=t+1;

                elseif A_rest[i,j] eq 10;
                    A[i,j]  = param[t]; t=t+1;
                elseif A_rest[i,j] eq 11;
                    A[i,j]  = param[t]; t=t+1;
                elseif A_rest[i,j] eq -11;
                    A[i,j]  = param[t]; t=t+1;


                elseif A_rest[i,j] eq 50;
                    xi = trunc(A_para[i,j]/100);
                    xj = A_para[i,j]-100*xi;
                    if (param[t]*A[xi,xj] ge 0);
                        A[i,j]  = param[t]; t=t+1;
                        param_b[i,j] = 0;
                    else;
                        A[i,j]       = 0; t=t+1;
                        param_b[i,j] = penalty*abs(param[t]);
                    endif;


                elseif A_rest[i,j] eq 60;
                    xi = trunc(A_para[i,j]/100);
                    xj = A_para[i,j]-100*xi;
                    if (param[t]*A[xi,xj] le 0);
                        A[i,j]  = param[t]; t=t+1;
                        param_b[i,j] = 0;
                    else;
                        A[i,j]       = 0; t=t+1;
                        param_b[i,j] = penalty*abs(param[t]);
                    endif;


                elseif A_rest[i,j] eq 80;
                    xi = trunc(A_para[i,j]/100);
                    xj = A_para[i,j]-100*xi;
                    A[i,j]  = A[xi,xj];
                elseif A_rest[i,j] eq 81;
                    xi = trunc(A_para[i,j]/100);
                    xj = A_para[i,j]-100*xi;
                    A[i,j]  = A[xi,xj] + param[t]; t=t+1;
                elseif A_rest[i,j] eq -81;
                    xi = trunc(A_para[i,j]/100);
                    xj = A_para[i,j]-100*xi;
                    A[i,j]  = A[xi,xj] + param[t]; t=t+1;


                elseif A_rest[i,j] eq 90;
                    A[i,j]  = 0;
                elseif A_rest[i,j] eq 99;
                    A[i,j]  = 1;
                else;
                    ? "in parametros";
                    stop;
                endif;
            j=j+1; endo;
        i=i+1; endo;


        if metodocom eq 0;
            gama = 0;
            sigZreg = zeros(cols(datareg),1);
        else;
            gama = ones(n,1);
            i=2; do while i le n;
                gama[i] = param[t]; t=t+1;
            i=i+1; endo;
    
            sigZreg = ones(cols(datareg),1);
            i=1; do while i le rows(sigZreg);
                sigZreg[i] = param[t]; t=t+1;
            i=i+1; endo;
        endif;



        retp(A,gama,sigZreg,param_o,param_b);   
    else;
        stop;
    endif;
endp;
            











/*********************************/
/* procedure finding the regimes */
/*********************************/
proc FindARegimes(param,Data);
    local i, j, gmmprov, gmmprob, gama, sigZreg, gmmweig, xi, xj, invA, gmmred;
        
        if metodored eq 0;
            if metodocom le 1;
                {A,gama,sigZreg,param_o,gmmpen} = parametros(A,A_rest,param,n,1);
                gmmweig = gmmvar[1,.]/sumc(gmmvar[1,.]');
                
                gmm = 0;
                i=1; do while i le cols(DataVCX);
                    gmmprov = xpnd(DataVCX[.,i]);
                    gmmprov = A * gmmprov * A';
                    gmmprov = gmmprov - (gama*gama' * sigZreg[i]);
                    gmmprov = diagrv(gmmprov,( (diag(gmmprov).<0).*abs(diag(gmmprov))*penalty ));
                    gmmprov = vech(gmmprov);
                    gmmprov = packr(gmmprov);
        
                    gmm     = gmm|(gmmprov*gmmweig[i]);
                i=i+1; endo;
        
                gmm = trimr(gmm,1,0);
                gmo = gmm;
                gmm = -(sumc(abs(gmm)^2));
            else;
                {A,gama,sigZreg,param_o,gmmpen} = parametros(A,A_rest,param_o,n,1);
                gmmweig = A;
    
                {A,gama,sigZreg,param_o,gmmpen} = parametros(A,A_rest,param,n,1);
                A = gmmweig;
                gmmweig = gmmvar[1,.]/sumc(gmmvar[1,.]');
                gmmweig = gmmvar[1,.];
                
                gmm = 0;
                i=1; do while i le cols(DataVCX);
                    gmmprov = xpnd(DataVCX[.,i]);
                    gmmprov = A * gmmprov * A';
                    gmmprov = gmmprov - (gama*gama' * sigZreg[i]);
                    gmmprov = diagrv(gmmprov,( (diag(gmmprov).<0).*abs(diag(gmmprov))*penalty ));
                    gmmprov = vech(gmmprov);
                    gmmprov = packr(gmmprov);
        
                    gmm     = gmm|(gmmprov*gmmweig[i]);
                i=i+1; endo;
        
                gmm = trimr(gmm,1,0);
                gmo = gmm;
                gmm = -(sumc(abs(gmm)^2))/rows(gmm);
            endif;



        elseif metodored eq 1;
                {A,gama,sigZreg,param_o,gmmpen} = parametros(A,A_rest,param,n,1);
                gmmweig = gmmvar[1,.]/sumc(gmmvar[1,.]');
                
                gmm = 0;
                i=1; do while i le cols(DataVCX);
                    gmmprov = xpnd(DataVCX[.,i]);
                    gmmprov = A * gmmprov * A';
                    gmmprov = gmmprov - (gama*gama' * sigZreg[i]);
                    gmmprov = diagrv(gmmprov,( (diag(gmmprov).<0).*abs(diag(gmmprov))*penalty ));
                    gmmprov = vech(gmmprov);
                    gmmprov = packr(gmmprov);
        
                    gmm     = gmm|(gmmprov*gmmweig[i]);
                i=i+1; endo;
        
                gmm = trimr(gmm,1,0);
                gmo = gmm;


                /* REDUCED FROM PENALTIES */
                gmmred = 0;
                if det(A) eq 0;
                    ? "you are screwed"; stop;
                else;
                    invA = inv(A);
                    i=1; do while i le n;
                        j=1; do while j le n;
                            if A_redd[i,j] eq 0;
                            elseif A_redd[i,j] eq 1;
                                gmmred = gmmred | (invA[i,j]<0)*abs(invA[i,j]);
                            elseif A_redd[i,j] eq -1;
                                gmmred = gmmred | (invA[i,j]>0)*abs(invA[i,j]);
                            elseif A_redd[i,j] eq 81;
                                xi = trunc(A_redp[i,j]/100);
                                xj = A_redp[i,j]-100*xi;
                                gmmred = gmmred | ( (invA[i,j])<(invA[xi,xj]) )*abs(invA[i,j]-invA[xi,xj]);
                            elseif A_redd[i,j] eq -81;
                                xi = trunc(A_redp[i,j]/100);
                                xj = A_redp[i,j]-100*xi;
                                gmmred = gmmred | ( (invA[i,j])>(invA[xi,xj]) )*abs(invA[i,j]-invA[xi,xj]);
                            else;
                                stop;
                            endif;
                        j=j+1; endo;
                    i=i+1; endo;
                    if rows(gmmred) gt 1;
                        gmmred = trimr(gmmred,1,0);
                        gmmred = gmmred*maxc(abs(gmm))*penalty/10;
                    else;
                        gmmred = 0;
                    endif;

                    gmm = gmm|gmmred;
                    gmp = gmm;
                    gmm = -(sumc(abs(gmm)^2))/rows(gmm);
                endif;


        else;
            ? "no metodo red";
            stop;
        endif;


    retp(gmm);
endp;








